#cython: language_level=3

'''
Created on 30 mars 2016

@author: coissac
'''

from obitools3.dms.obiseq import Nuc_Seq


def fastaIterator(lineiterator, 
                  int skip=0,
                  only=None,
                  firstline=None,
                  int buffersize=100000000
                 ):
    cdef LineBuffer lb
    cdef str        ident
    cdef str        definition
    cdef dict       tags
    cdef list       s
    cdef bytes      sequence
    cdef int        skipped, ionly, read
#    cdef OBI_Seq    seq
    
    if only is None:
        ionly=-1
    else:
        ionly=int(only)

    if isinstance(lineiterator,(str,bytes)):
        lineiterator=uopen(lineiterator)
    
    if isinstance(lineiterator, LineBuffer):
        lb=lineiterator
    else:
        lb=LineBuffer(lineiterator,buffersize)
    
    skipped = 0
    i = iter(lb)
    
    if firstline is None:
        line = next(i)
    else:
        line = firstline
        
    
    while True:
        
        if read >= ionly:
            break
                
        while skipped < skip :
            line = next(i)
            try:
                while line[0]!='>':
                    line = next(i)
            except StopIteration:
                pass
            skipped += 1

        ident,tags,definition = parseHeader(line)
        s = []
        line = next(i)
            
        try:
            while line[0]!='>':
                s.append(str2bytes(line)[0:-1])
                line = next(i)
        
        except StopIteration:
            pass
        
        sequence  = b"".join(s)
                
    #         seq = OBI_Seq(id,
    #                       sequence,
    #                       definition,
    #                       tags=tags,
    #                       )
                
        yield { "id"         : ident,
                "definition" : definition,
                "sequence"   : sequence,
                "quality"    : None,
                "offset"     : None,
                "tags"       : tags,
                "annotation" : {}
              }
        
        read+=1

    
def fastaNucIterator(lineiterator, 
                     int skip=0,
                     only=None,
                     firstline=None,
                     int buffersize=100000000
                    ):
    cdef LineBuffer lb
    cdef str        ident
    cdef str        definition
    cdef dict       tags
    cdef list       s
    cdef bytes      sequence
    cdef int        lines_to_skip, ionly, read
#    cdef OBI_Seq    seq
    
    if only is None:
        ionly=-1
    else:
        ionly=int(only)

    if isinstance(lineiterator,(str,bytes)):
        lineiterator=uopen(lineiterator)
    
    if isinstance(lineiterator, LineBuffer):
        lb=lineiterator
    else:
        lb=LineBuffer(lineiterator,buffersize)


    skipped = 0
    read = 0
    i = iter(lb)
    
    if firstline is None:
        line = next(i)
    else:
        line = firstline
        
    while True:
        
        if read >= ionly:
            break
       
        while skipped < skip :
            line = next(i)
            try:
                while line[0]!='>':
                    line = next(i)
            except StopIteration:
                pass
            skipped += 1

        ident,tags,definition = parseHeader(line)
        s = []
        line = next(i)
        
        try:
            while line[0]!='>':
                s.append(str2bytes(line)[0:-1])
                line = next(i)
        except StopIteration:
            pass
        
        sequence  = b"".join(s)        
        
#        seq = 
        seq = Nuc_Seq(ident,
                      sequence,
                      definition,
                      None,-1,
                      tags)
        
        yield seq
        
#         yield { "id"         : ident,
#                 "definition" : definition,
#                 "sequence"   : sequence,
#                 "quality"    : None,
#                 "offset"     : None,
#                 "tags"       : tags,
#                 "annotation" : {}
#               }
        
        read+=1
        
    
        
        